HDU - 4771—————Stealing Harry Potter's Precious

Harry Potter has some precious. For example, his invisible robe, his wand and his owl. When Hogwarts school is in holiday, Harry Potter has to go back to uncle Vernon's home. But he can't bring his precious with him. As you know, uncle Vernon never allows such magic things in his house. So Harry has to deposit his precious in the Gringotts Wizarding Bank which is owned by some goblins. The bank can be considered as a N × M grid consisting of N × M rooms. Each room has a coordinate. The coordinates of the upper-left room is (1,1) , the down-right room is (N,M) and the room below the upper-left room is (2,1)..... A 3×4 bank grid is shown below: 



  Some rooms are indestructible and some rooms are vulnerable. Goblins always care more about their own safety than their customers' properties, so they live in the indestructible rooms and put customers' properties in vulnerable rooms. Harry Potter's precious are also put in some vulnerable rooms. Dudely wants to steal Harry's things this holiday. He gets the most advanced drilling machine from his father, uncle Vernon, and drills into the bank. But he can only pass though the vulnerable rooms. He can't access the indestructible rooms. He starts from a certain vulnerable room, and then moves in four directions: north, east, south and west. Dudely knows where Harry's precious are. He wants to collect all Harry's precious by as less steps as possible. Moving from one room to another adjacent room is called a 'step'. Dudely doesn't want to get out of the bank before he collects all Harry's things. Dudely is stupid.He pay you $1,000,000 to figure out at least how many steps he must take to get all Harry's precious.

Input

  There are several test cases. 
  In each test cases: 
  The first line are two integers N and M, meaning that the bank is a N × M grid(0<N,M <= 100). 
  Then a N×M matrix follows. Each element is a letter standing for a room. '#' means a indestructible room, '.' means a vulnerable room, and the only '@' means the vulnerable room from which Dudely starts to move. 
  The next line is an integer K ( 0 < K <= 4), indicating there are K Harry Potter's precious in the bank. 
  In next K lines, each line describes the position of a Harry Potter's precious by two integers X and Y, meaning that there is a precious in room (X,Y). 
  The input ends with N = 0 and M = 0 

Output

  For each test case, print the minimum number of steps Dudely must take. If Dudely can't get all Harry's things, print -1. 

Sample Input

2 3
##@
#.#
1
2 2
4 4
#@##
....
####
....
2
2 1
2 4
0 0

Sample Output

-1
5

题意:给你一个N*M的矩阵,“#”代表墙,不能走;“.”代表路可以走;“@”代表其实位置;

给你一个K,表示在图中有K个宝藏;

问你,从起点到拿到K个宝藏的最短路是多少:

显然,我的做法有点暴力了,应为他k最多有4;n那么加上起点就是是5个点,两两之间跑一个最短路,也就是10种情况,然后取最小值就行;拿不到k个宝藏就输出-1;

 

ac代码:

#include <cstdio>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <queue>
#include <cstring>
#include <string>
#include <vector>

using namespace std;
typedef long long LL;
const int maxn =  300;
const int INF = 1e9;

struct po
{
	int x, y,tep;
}s, t, q;

char map[maxn][maxn];
int vis[maxn][maxn], xx[maxn], yy[maxn];
int kk[maxn];
int n, m, k;
int nx[5] = {-1, 0, 1, 0}, ny[5] = {0, -1, 0, 1};
int bfs()   //正常BFS找最短路
{
	queue <po> q;
	while(!q.empty()) q.pop();
	vis[s.x][s.y] = 1;
	q.push(s);
	while(!q.empty())
	{
		po now = q.front();
		if(now.x == t.x && now.y == t.y)  return now.tep;
		for(int i = 0;i <= 3;i++)
		{
			po nt;
		int dx = nt.x = now.x + nx[i];
		int dy = nt.y= now.y + ny[i];
		if(dx < 1 || dy < 1 || dx > n || dy > m) continue;
		if(map[dx][dy] == '#' || vis[dx][dy] == 1)  continue;
				vis[nt.x][nt.y] = 1;
				nt.tep = now.tep + 1;
				q.push(nt);
		}
		q.pop();
	}
	return -1;
}

int main()
{
	while(~scanf("%d %d",&n ,&m) && n != 0 && m != 0)  //0 , 0结束
	{
		for(int i = 1;i <= n;i++)
			for(int j = 1;j <= m;j++)
			{
				scanf(" %c",&map[i][j]);
				if(map[i][j] == '@')
				{
					q.x = i, q.y = j;   //记录起点
				}
			}
			scanf("%d",&k);
			for(int i = 1;i <= k;i++)
			{
				int x, y;
				scanf("%d %d",&x, &y);
				xx[i] = x, yy[i] = y, kk[i] = i;   //k个宝藏的位置,KK[i]为宝藏编号
			}
			int ans = INF;   //初始距离最大化
			do{
				int sum = 0;
				for(int i = 1;i <= k;i++) 
				{
					memset(vis, 0,sizeof(vis));
					if(i != 1) s.x = xx[kk[i - 1]], s.y = yy[kk[i - 1]], s.tep = 0;  //如果i==1,表示的是@点到k[i]求最短路;  i!=1表示以k[i-1]为起点,k[i]为终点跑最短路;
					else s.x = q.x, s.y = q.y, s.tep = 0;
					t.x = xx[kk[i]], t.y = yy[kk[i]];
					int f = bfs();  //能不能走到
					if(f == -1)   //不能走到
					{
						sum = -1;  
						break;
					}
					else sum += f;  //能走到 这中情况的总sum+=f
				}
				if(sum != -1) ans = min(ans, sum);  //每种情况取最小值
			}while(next_permutation(kk + 1,kk + k + 1));  //暴力两两之间的位置  
			if(ans == INF)  ans = -1; //不能取到k个宝藏
			printf("%d\n",ans);
	}
	return 0;
}

 

猜你喜欢

转载自blog.csdn.net/strawberry_595/article/details/81142033